Dokumentation für die oebbApi 
==========


Allgemeines
-----------


**Was brauche ich dafür?**
* Einen Server, der die PHP-Files ausführen kann. Es genügt auch ein Freehoster.
* PhpQuery in der Version 0.9.5 oder höher. [http://code.google.com/p/phpquery/](http://code.google.com/p/phpquery/)



**Was müssen ich beachten?**
* Der Code bzw. die API ist nicht von einem Profi, sondern von einem Lehrling im ersten Lehrjahr programmiert worden. Deswegen bitte ich um ausschließlich konstruktive Kritik.
* Zu jeder Funktion gibt es auch ein Beispiel. Siehe PDF.
* Es gelten die Allgemeinen Geschäftsbedingungen und die Nutzungsbedingungen von [oebb.at](http://oebb.at). [http://www.oebb.at/de/Nutzungsbedingungen/index.jsp](http://www.oebb.at/de/Nutzungsbedingungen/index.jsp)
* Es wird keine Haftung übernommen! Sie sind für ihr Handeln selbst verantwortlich. Der Rechtsweg ist ausgeschlossen!



Wenn Sie etwas für einen Lehrling in ersten Lehrjahr spenden möchten, dann können Sie das über diese Links tun. :)


 [Flattr](https://flattr.com/profile/internetztube)

[PayPal](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=TKFLMZMXM3Z64)



Station validieren - validate()
-----------

**Wissenwertes**
1. Es ist zu beachten, dass bei einem Aufruf mehrere Stationen zurückkommen können.
2. Für den weiteren Vorgang wird ausschließlich der name („value“) benötigt.

**Useage**

| Name | Typ    | Beschreibung     | Zwingend benötigt |
| ---- | ------ | ---------------- | ----------------- |
| name | string | Name der Station | X                 |

**Rückgabewerte**

| Name  | Typ    | Beschreibung                | Wird benötigt |
| ----- | ------ | --------------------------- | ------------- |
| value | string |	Gültiger Name der Station   | X             |  
| id    | int    | Irgend eine ÖBB Stations ID |               |


Verbindung suchen - get()
-----------

**Wissenwertes**
1. Die Stations-Namen können leicht abgeändert eigegeben werden. Aus „St.    Pölten“ wird „St.Pölten Hbf“
2. Wenn die Parameter „date“, „time“ nicht verwendet oder mit NULL angegeben werden, wird automatisch das aktuelle Datum bzw. Zeit verwendet.
3. Die „id“ ist für die Verwendung der Funktionen „getDetails“ und in Folge „getCoords“ essenziell. 
4. Wenn Sie drei Verbindungen in der Vergangenheit (relativ zur ersten Verbindung) möchten, dann verwenden Sie „earlier“ als Anfangszeit und fügen Sie zu „amount“ drei dazu. Wenn Sie drei Verbindungen weiter in der Zukunft möchten, dann lassen die Anfangszeit gleich und erhöhen Sie einfach „amount“ um 3.

**Useage**

| Name      | Typ    | Beschreibung             | Zwingend benötigt |
| --------- | ------ | ------------------------ | ----------------- |
| departure | string | Name der Abfahrtsstation | X                 |
| arrival   | string | Name der Ankunftsstation | X                 |
| amount    | int    | Anzahl der Verbindungen  | X                 |

**Rückgabewerte**

| Name         | Typ    | Beschreibung                                  | Wird benötigt |
| ------------ | ------ | --------------------------------------------- | ------------- |
| startStation | string | Name der Abfahrtsstation                      |               |
| endStation   | string | Name der Ankunftsstation                      |               |
| startDate    | string | Abfahrtsdatum, wichtig bei Nachtzügen         |               |
| endDate      | string | Ankunftsdatum                                 |               |
| startTime    | string | Abfahrtszeit                                  |               |
| endTime      | string | Ankunftszeit                                  |               |
| duration     | string | Fahrtdauer                                    |               |
| changes      | int    | Umstiege                                      |               |
| buyLink      | string | Kauflink zur Verbindung                       |               |
| changesLink  | string | Link zur Verbindung auf oebb.at               |               |
| products     | array  | Alle Verkehrsmittel mit Bezeichnung und Bild  |               |
| prognose     | string | BETA, Verspätungen                            |               |
| id           | int    | Nummer der Verbindung der Anfrage             |               |
| earlier      | string | Siehe oben.                                   |               |



Details einer Verbindung - getDetails
-----------

**Wissenwertes**

1. Von der Funktion „getDetails“ bekommen Sie die essenziellen Infos einer spezifischen Verbindung.
2. Für den Aufruf benötigen Sie lediglich die „id“ der Verbindung. Diese „id“ bekommen Sie von der Funktion „get“ zurück.
3. Funktioniert nur bei einer erfolgreich ausgeführten Suche (get).

**Useage**

| Name | Typ | Beschreibung                                 | Zwingend benötigt |
| ---- | --- | -------------------------------------------- | ----------------- |
| id   | int | Index der spezifischen Verbindung. Siehe get | X                 |






